package;

import FlxAssets;
import flash.ui.Mouse;
import org.flixel.FlxU;
import org.flixel.FlxButton;
import org.flixel.FlxG;
import org.flixel.FlxGroup;
import org.flixel.FlxPoint;
import org.flixel.FlxSprite;
import org.flixel.FlxState;
import org.flixel.FlxText;
import org.flixel.FlxObject;
import nme.Assets;


class BreakBlock2 extends FlxSprite
	{
	
		//private const GRAVITY:int = 500;
		inline private static var GRAVITY = 500;
		inline private static var  MIN_FRICTION = 20; 
		
		public var isLocked:Bool;
		public var beingPushed:Bool;
		
		inline private static var  STOP_VEL = 10.0;	// stop & lock if moving slower than this
		inline private static var  ANTI_SLIDE = 4;	// factor to reduce slide by (multiplied by velocity and added to friction)
			// 0 means slippery (just use MIN_FRICTION). 0.5-1 is "normal" slide.  2+ is very little slide
		
		public function new(X:Float,Y:Float):Void
		{
			super(X, Y);
			loadGraphic(FlxAssets.breakImg, true, true, 40, 40, true);
			unlock();
			color = 0x33FF7777;
		}
		
		override public function update():Void
		{
			

			if (beingPushed)
			{
				if (isLocked) unlock();
				drag.x = 0;
			}
			else // not being pushed
			{
				var velX:Float = FlxU.abs(velocity.x);
				drag.x = MIN_FRICTION + velX * ANTI_SLIDE;
				 if (!isLocked && isTouching(FlxObject.FLOOR) && velX < STOP_VEL){
					lock();
				}
				else{
					if(!isTouching(FlxObject.FLOOR)){
						unlock();
					}
				}

			}

			
			// post update (reset flags)
			beingPushed = false;
		}
		
		// make sure that blocks stop moving when not being pushed or falling
		public function lock():Void
		{
			// move player out of block if still overlapping
			// otherwise, player will be able to move "into" the block.
			//if (PlayState.player != null && overlaps(PlayState.player))
			//{
				// only happens when at high velocity...
				//if (PlayState.player.isCharging)
				//{
				//	if (PlayState.player.facing == RIGHT) PlayState.player.x -= width;
				//	else PlayState.player.x += width;
				//}
			//}
			
			// lock the block.
			isLocked = true;
			immovable = true;
			moves = false;
			
			velocity.x = 0;
			velocity.y = 0;
			acceleration.y = 0;
		}
		
		// make pushable again
		public function unlock():Void
		{
			isLocked = false;
			immovable = false;
			moves = true;
			//color = 0x77FFFFFF;
			acceleration.y = GRAVITY;
		}
	}
