package;

import flash.ui.Mouse;
import org.flixel.FlxButton;
import org.flixel.FlxG;
import org.flixel.FlxGroup;
import org.flixel.FlxPoint;
import org.flixel.FlxSprite;
import org.flixel.FlxState;
import org.flixel.FlxText;
import org.flixel.FlxBasic;
import org.flixel.FlxTilemap;
import org.flixel.FlxObject;
import nme.Assets;

import com.eclecticdesignstudio.motion.Actuate;
import com.eclecticdesignstudio.motion.easing.Elastic;



class Level6 extends BaseLevel
{
	private var door1:Door;
	private var button1:Button;
	private var pU1:FlxSprite;
	
	
	
	override public function create():Void
	{
	

		backGround = new FlxSprite(0,0);
		backGround.alpha = .65;
		backGround.loadGraphic(FlxAssets.bgImage2,false,false,800,600);
		add(backGround);


		map = new FlxTilemap();
		map.loadMap(Assets.getText("assets/mapCSV_Group1_Level6.csv"),FlxAssets.tileImg2,20,20,FlxTilemap.OFF);
		add(map);
		super.create();

		//reput the taco
		taco.y=340;
		taco.x=738;

		//place the player
		ourPlayer.x=40;
		ourPlayer.y=240;
		ourPlayer.facing = FlxObject.LEFT;
	
		//add other layer stuff
		//var redBottomL:Door = new Door(340,380,2);
		//doorGroup.add(redBottomL);

		//var redBottomR:Door = new Door(450,380,2);
		//doorGroup.add(redBottomR);

		//var button2:Button = new Button(394,574,this,2);
		//buttonGroup.add(button2);


	    var testEnemy1:Enemy1 = new Enemy1(160,20);
		enemyGroup.add(testEnemy1);

		var testEnemy2:Enemy1 = new Enemy1(200,20);
		enemyGroup.add(testEnemy2);


		var testEnemy3:Enemy1 = new Enemy1(280,20);
		testEnemy3.speed*=-1;
		enemyGroup.add(testEnemy3);

		var testEnemy4:Enemy1 = new Enemy1(520,20);
		testEnemy4.speed*=-1;
		enemyGroup.add(testEnemy4);

		var testEnemy5:Enemy1 = new Enemy1(560,20);
		testEnemy5.speed*=-1;
		enemyGroup.add(testEnemy5);

		var testEnemy6:Enemy1 = new Enemy1(600,20);
		testEnemy6.speed*=-1;
		enemyGroup.add(testEnemy6);


		for (i in 0...31) {
			var testSparks2:Sparks = new Sparks(165+(i*15),487,.5,3);
			enviroGroup.add(testSparks2);
		}

		for (i in 0...14) {
			var testSparks4:Sparks = new Sparks(163+(i*15),440,.5,3);
			testSparks4.scale.y=-1;
			enviroGroup.add(testSparks4);
		}

		for (i in 0...14) {
			var testSparks4:Sparks = new Sparks(423+(i*15),440,.5,3);
			testSparks4.scale.y=-1;
			enviroGroup.add(testSparks4);
		}

		for (i in 0...15) {
			var testSparks3:Sparks = new Sparks(145+(i*15),407,.5,3);
			enviroGroup.add(testSparks3);
		}

		for (i in 0...15) {
			var testSparks3:Sparks = new Sparks(426+(i*15),407,.5,3);
			enviroGroup.add(testSparks3);
		}


		var vSparks:Sparks = new Sparks(380,180,4,2);
		//enviroGroup.add(vSparks);

		pU1 = new PowerU(162,460);
		powerUGroup.add(pU1);

		var pU2:PowerU = new PowerU(633,460);
		pU2.facing = FlxObject.LEFT;
		powerUGroup.add(pU2);


		var hdoor1:Door = new Door(215,30);
		hdoor1.makeHorz();
		//hdoor1.offset.y=10;
		doorGroup.add(hdoor1);

		var hdoor2:Door = new Door(575,30);
		hdoor2.makeHorz();
		doorGroup.add(hdoor2);

		var hdoor3:Door = new Door(395,110);
		hdoor3.makeHorz();
		doorGroup.add(hdoor3);

		var hdoor4:Door = new Door(395,190);
		hdoor4.makeHorz();
		doorGroup.add(hdoor4);






		var blueButton:Button = new Button(395,274,this);
		buttonGroup.add(blueButton);


		stars.x = taco.x;
		stars.y = taco.y-6;


		//Power Up Section
		//add(powerUpGroup);
		//type of powerup, x location, chance of birth, time frame to birth
		powerUpTimer = haxe.Timer.delay(callback(createPowerUp,1,FlxG.randomRange2(600,200),1), FlxG.randomRange2(5000,1000));
		

	



	


		
	}


	override public function nextLevel():Void{
		powerUpTimer.stop();
		FlxG.switchState(new Level7());
	}

	override private function resetLevel():Void{
		powerUpTimer.stop();
 		  if (FlxAssets.gameMode==2) {
 		 	if (FlxAssets.hotLives==1) {
 		 		hotGameOver();
 		 	}
 		 	else{
 		 		FlxAssets.hotLives--;
 		 	 	FlxG.switchState(new Level6(2));
 		 	}
 		 }
 		 
 		 if (FlxAssets.gameMode==1) {
 		 	if (FlxAssets.tacoNum>1) {
 				FlxAssets.tacoNum--;
 		 	}
 		 	 FlxG.switchState(new Level6(2));
 		}
 	}
	


	

	
	override public function update():Void
	{
		super.update();

		
		FlxG.collide(doorGroup,robotGroup);
		FlxG.collide(buttonGroup,robotGroup,buttonHit);
		FlxG.collide(enemyGroup,map);
		FlxG.collide(enemyGroup,doorGroup);
		FlxG.collide(ourPlayer,enviroGroup,enviroHit);
		FlxG.collide(robotGroup,enviroGroup,enviroHit);

		FlxG.collide(lazerGroup,powerUGroup,explodePowerU);
		FlxG.collide(lazerGroup,enemyGroup,enemyHit);
		FlxG.collide(lazerGroup,map,mapZap);
		FlxG.collide(lazerGroup,doorGroup,basicZap);
		updateParts();

		

	}//end of update

	

	

}