package;

import flash.ui.Mouse;
import org.flixel.FlxButton;
import org.flixel.FlxG;
import org.flixel.FlxGroup;
import org.flixel.FlxPoint;
import org.flixel.FlxSprite;
import org.flixel.FlxState;
import org.flixel.FlxText;
import org.flixel.FlxObject;


class Player extends FlxSprite
{
	//This is for our messages
	private var topText:FlxText;
	public var jump:Float;
	public var onGround:Bool;
	public var ourSpeed:Float;
	public var stillTime:Float;
	public var headless:Bool;
	public var control:Bool;
	public var lazerCharging:Bool;
	
	
	public function new(X:Int, Y:Int)
	{
		
		super(X,Y);
		loadGraphic(FlxAssets.robotImg,true,true,20,24);
		jump=0;
		onGround = false;
		ourSpeed = 155;
		width=8;
		this.offset.x=6;
		offset.y=-2;
		stillTime = 0;
		headless = false;
		control = true;

		lazerCharging = false;

		acceleration.y=1100;
		//maxVelocity.y = 700;
		maxVelocity.y=700;
		this.drag.x=ourSpeed*3;
		addAnimation("walk",[2,3,4,3],12);
		addAnimation("jump",[4],12);
		addAnimation("stopped",[1,1,1,1,1,1,1,1,1,1,0,0,1],12);
		addAnimation("noHead",[6,12,13,14,13,12,6,12,13,14,13,12,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,12,13,14,13,12,6,12,13,14,13,12,6,12,13,14,13,12,6,12,13,14,13,12],12);
		addAnimation("walk2",[8,9,10,9],12);
		addAnimation("jump2",[10],12);
		addAnimation("stopped2",[6],12);


		play("stopped");
		velocity.x=100;

	}
	
	/*
	override public function create():Void
	{
	
		

	}
	*/
	

	override public function update():Void
	{
		if(control){
			if (touching == FlxObject.DOWN){
				jump = 0;
				onGround = true;
			}
			if((jump>=0) && FlxG.keys.UP){
				onGround=false;
				stillTime=0;
				jump += FlxG.elapsed;
				if (headless) {
					play("jump2");
				}
				else{
					play("jump");
				}
				
				if(jump> 0.25){
					jump = -1;
				}
			}
			else{
				jump = -1;
			}

			if(jump>0){
				if(jump < 0.065)
					velocity.y = -100;
				else
					velocity.y = -maxVelocity.y*.55;
					//velocity.y = -maxVelocity.y*.5;

			}
			if(y<-24){
				velocity.y=0;
			}



			if(FlxG.keys.LEFT&&x>0){
				stillTime=0;
				this.facing= FlxObject.LEFT;
				velocity.x=-ourSpeed;
				if(onGround){
					if (headless) {
						play("walk2");
					}
					else{
						play("walk");
					}
				}
			}
			else if(FlxG.keys.RIGHT&&x+8<FlxG.width){
				stillTime=0;
				velocity.x=ourSpeed;
				facing = FlxObject.RIGHT;
				if(onGround){
					if (headless) {
						play("walk2");
					}
					else{
						play("walk");
					}
				}
			}
			else{
				velocity.x=0;
				if(onGround)
				{
					stillTime+=FlxG.elapsed;
					if(stillTime>=3){
						if (headless) {
							play("stopped2");
						}
						else{
							play("stopped");
						}
					}
					else{
						if (headless) {
							frame=9;
						}
						else{
							frame=2;
						}	
					}
				}
				else{
					if (headless) {
						play("jump2");
					}
					else{
						play("jump");
					}
				}
			}

		}//end of control check
		else{
			play("noHead");
		}


		
	}//end of update


	public function loseHead():Void{
		// loadGraphic(FlxAssets.robotHeadlessImg,true,true,20,12);
		velocity.x=0;
		//this.acceleration.y=2000;
		control = false;
		//facing = FlxObject.RIGHT;
		headless = true;
		height =14;
		y+=8;
		width=8;
		//height=12;
		offset.y=8;
		this.offset.x=6;
		//offset.y=;

	}//end of lose head

	public function getHead():Void{
		y-=12;
		//loadGraphic(FlxAssets.robotImg,true,true,20,24);
		height=24;
		offset.y=-2;
		control = true;
		//facing = FlxObject.RIGHT;
		headless = false;
		width=8;
		this.offset.x=6;
		

	}
	
	
	

}